// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package example

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ExampleRPCClient is the client API for ExampleRPC service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ExampleRPCClient interface {
	Hello(ctx context.Context, in *Greeting, opts ...grpc.CallOption) (*Greeting, error)
}

type exampleRPCClient struct {
	cc grpc.ClientConnInterface
}

func NewExampleRPCClient(cc grpc.ClientConnInterface) ExampleRPCClient {
	return &exampleRPCClient{cc}
}

func (c *exampleRPCClient) Hello(ctx context.Context, in *Greeting, opts ...grpc.CallOption) (*Greeting, error) {
	out := new(Greeting)
	err := c.cc.Invoke(ctx, "/ExampleRPC/Hello", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ExampleRPCServer is the server API for ExampleRPC service.
// All implementations must embed UnimplementedExampleRPCServer
// for forward compatibility
type ExampleRPCServer interface {
	Hello(context.Context, *Greeting) (*Greeting, error)
	mustEmbedUnimplementedExampleRPCServer()
}

// UnimplementedExampleRPCServer must be embedded to have forward compatible implementations.
type UnimplementedExampleRPCServer struct {
}

func (UnimplementedExampleRPCServer) Hello(context.Context, *Greeting) (*Greeting, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Hello not implemented")
}
func (UnimplementedExampleRPCServer) mustEmbedUnimplementedExampleRPCServer() {}

// UnsafeExampleRPCServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ExampleRPCServer will
// result in compilation errors.
type UnsafeExampleRPCServer interface {
	mustEmbedUnimplementedExampleRPCServer()
}

func RegisterExampleRPCServer(s grpc.ServiceRegistrar, srv ExampleRPCServer) {
	s.RegisterService(&ExampleRPC_ServiceDesc, srv)
}

func _ExampleRPC_Hello_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Greeting)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExampleRPCServer).Hello(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/ExampleRPC/Hello",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExampleRPCServer).Hello(ctx, req.(*Greeting))
	}
	return interceptor(ctx, in, info, handler)
}

// ExampleRPC_ServiceDesc is the grpc.ServiceDesc for ExampleRPC service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ExampleRPC_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "ExampleRPC",
	HandlerType: (*ExampleRPCServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Hello",
			Handler:    _ExampleRPC_Hello_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "example.proto",
}
